Added -I option to rsync to ignore timestamps and size when copying over a remote...
[backups/.git] / scripts / burn-imgs.sh
index da5b11b911591dc15f2239bf663a8b5ae7dd96aa..69d192fd4c3ba92eb3d5adbcf1cb3b66d456084b 100755 (executable)
@@ -25,6 +25,20 @@ img=${imgmd5%.md5sum}
 
 touch $noburnfile
 
+# Now check to see if we need to cache the image to a local drive before burning the image
+if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+  rsync -av --exclude '*.mnt' $img* $cacheburnimgdir >> $logfile 2>&1
+  if [ $? != 0 ]; then
+    sleep 60
+    rsync -aIv --exclude '*.mnt' $img* $cacheburnimgdir >> $logfile 2>&1
+    if [ $? != 0 ]; then
+      cat $logfile | mailx -s "backups: failed to cache $img to local dir $cacheburnimgdir !!!" $mailto
+      exit 1
+    fi
+  fi
+  img=$cacheburnimgdir/$(basename "$img")
+fi
+
 # A little paranoia.  Make sure the disk image file is there.
 [ -z "$img" ] && exit 1
 [ -s "$img" ] || exit 1
@@ -34,12 +48,12 @@ $cronstopstart stop
 renice -10 $$
 
 # Burn the image to a disk.
-cdrecord-wrapper.sh $cdrecordopts dev=$sdev $img > $logfile 2>&1
+cdrecord-wrapper.sh $cdrecordopts dev=$sdev $img >> $logfile 2>&1
 
 if [ "0" != "$?" ]; then
   echo >&2 "cdrecord failed!"
   $cronstopstart start
-  cat $logfile | grep -v "MB written" | grep -v "to quit" | mailx -s "backups: failed to burn $img!!!" $mailto
+  cat $logfile | grep -v -e '[\b\r]' | mailx -s "backups: failed to burn $img!!!" $mailto
   exit 1
 fi
 
@@ -58,14 +72,17 @@ dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print$1}' > $md
 if ! cmp $md5sum $img.md5sum; then
   echo "md5sum check FAILED" >> $logfile
   echo "dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print\$1}' > $md5sum" >> $logfile
-  e2label $dev >> $logfile
-  cat $logfile | grep -v "MB written" | grep -v "to quit" | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
+  e2label $dev >> $logfile 2>&1
+  cat $logfile | grep -v -e '[\b\r]' | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
   exit 1
 fi
 
 # Record the date in the stat file to indicate that this burn was a success
 date >> $img.stat
 
+# Update the source file stat file if we burned a cached copy of the image
+[[ $cacheburnimg == 1 && -d $cacheburnimgdir ]] && date >> ${imgmd5%.md5sum}.stat
+
 { # Send e-mail
   echo "Image md5sum:"
   cat $img.md5sum
@@ -76,11 +93,18 @@ date >> $img.stat
   cat $img.stat
   echo
   cat $logfile
-} | grep -v "MB written" | grep -v "to quit" | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto > $logfile 2>&1
+} | grep -v -e '[\b\r]' | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto >> $logfile 2>&1
 
 # Two lines in the stat file indicate two successful burns.  Clean-up the image.
 if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "$makeXcopies" ]; then
-  # Burned the image twice.  Removing it and associated files!
+  # Burned the image $makeXcopies number of times.  Removing it and associated files! 
+  if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+    # Remove our cached copy of the image, its md5sum, and stat file
+    rm -f $img{,.md5sum,.stat}
+    # Now restore our $img variable to point back to the original source file
+    img=${imgmd5%.md5sum}
+  fi
   rm -f $img{,.md5sum,.stat}
   [ -d $img.mnt ] && rmdir $img.mnt
 fi
+